/*******************************************************************************
* File Name: ShiftOut_1_Count7_Byte.h
* Version 1.0
*
* Description:
*  This header file contains registers and constants associated with the
*  Count7 component.
*
* Note:
*
********************************************************************************
* Copyright 2013, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_COUNT7_ShiftOut_1_Count7_Byte_H)
#define CY_COUNT7_ShiftOut_1_Count7_Byte_H

#include "cyfitter.h"

#if ((CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3) || \
     (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC4) || \
     (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5))
    #include "cytypes.h"
    #include "CyLib.h"
#else
    #include "syslib/cy_syslib.h"
#endif


/***************************************
* Function Prototypes
***************************************/
void  ShiftOut_1_Count7_Byte_Init(void) ;
void  ShiftOut_1_Count7_Byte_Enable(void) ;
void  ShiftOut_1_Count7_Byte_Start(void) ;
void  ShiftOut_1_Count7_Byte_Stop(void) ;
void  ShiftOut_1_Count7_Byte_WriteCounter(uint8 count) ;
uint8 ShiftOut_1_Count7_Byte_ReadCounter(void) ;
void  ShiftOut_1_Count7_Byte_WritePeriod(uint8 period) ;
uint8 ShiftOut_1_Count7_Byte_ReadPeriod(void) ;
void  ShiftOut_1_Count7_Byte_SaveConfig(void) ;
void  ShiftOut_1_Count7_Byte_RestoreConfig(void) ;
void  ShiftOut_1_Count7_Byte_Sleep(void) ;
void  ShiftOut_1_Count7_Byte_Wakeup(void) ;


/***************************************
*     Data Struct Definitions
***************************************/
/* Structure to save registers before go to sleep */
typedef struct
{
    uint8 enableState;
    uint8 count;
} ShiftOut_1_Count7_Byte_BACKUP_STRUCT;


/***************************************
*           Global Variables
***************************************/
extern ShiftOut_1_Count7_Byte_BACKUP_STRUCT ShiftOut_1_Count7_Byte_backup;
extern uint8 ShiftOut_1_Count7_Byte_initVar;


/***************************************
* Initial Parameter
***************************************/
#define ShiftOut_1_Count7_Byte_INITIAL_PERIOD               (8u)


/***************************************
* Registers
***************************************/
#define ShiftOut_1_Count7_Byte_COUNT_REG                    (*(reg8 *) ShiftOut_1_Count7_Byte_Counter7__COUNT_REG)
#define ShiftOut_1_Count7_Byte_COUNT_PTR                    ( (reg8 *) ShiftOut_1_Count7_Byte_Counter7__COUNT_REG)
#define ShiftOut_1_Count7_Byte_PERIOD_REG                   (*(reg8 *) ShiftOut_1_Count7_Byte_Counter7__PERIOD_REG)
#define ShiftOut_1_Count7_Byte_PERIOD_PTR                   ( (reg8 *) ShiftOut_1_Count7_Byte_Counter7__PERIOD_REG)
#define ShiftOut_1_Count7_Byte_AUX_CONTROL_REG              (*(reg8 *) ShiftOut_1_Count7_Byte_Counter7__CONTROL_AUX_CTL_REG)
#define ShiftOut_1_Count7_Byte_AUX_CONTROL_PTR              ( (reg8 *) ShiftOut_1_Count7_Byte_Counter7__CONTROL_AUX_CTL_REG)


/***************************************
* Register Constants
***************************************/
#define ShiftOut_1_Count7_Byte_COUNTER_START                (0x20u)

/* This constant is used to mask the TC bit (bit#7) in the Count register */
#define ShiftOut_1_Count7_Byte_COUNT_7BIT_MASK              (0x7Fu)


#endif /* CY_COUNT7_ShiftOut_1_Count7_Byte_H */


/* [] END OF FILE */
